"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class GermlineSample(ProtocolElement):
    """
    A germline sample
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "labSampleId",
        "sampleId",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_9_0 import participant as participant_1_5_0

        return {
            "sampleCollectionOperationsQuestions": participant_1_5_0.SampleCollectionOperationsQuestions,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_9_0 import participant as participant_1_5_0

        return {
            "method": participant_1_5_0.Method,
            "preparationMethod": participant_1_5_0.PreparationMethod,
            "product": participant_1_5_0.Product,
            "programmePhase": participant_1_5_0.ProgrammePhase,
            "source": participant_1_5_0.SampleSource,
            "storageMedium": participant_1_5_0.StorageMedium,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_9_0 import participant as participant_1_5_0

        return {
            "org.gel.models.participant.avro.Method": participant_1_5_0.Method,
            "org.gel.models.participant.avro.PreparationMethod": participant_1_5_0.PreparationMethod,
            "org.gel.models.participant.avro.Product": participant_1_5_0.Product,
            "org.gel.models.participant.avro.ProgrammePhase": participant_1_5_0.ProgrammePhase,
            "org.gel.models.participant.avro.SampleCollectionOperationsQuestions": participant_1_5_0.SampleCollectionOperationsQuestions,
            "org.gel.models.participant.avro.SampleSource": participant_1_5_0.SampleSource,
            "org.gel.models.participant.avro.StorageMedium": participant_1_5_0.StorageMedium,
            "org.gel.models.participant.avro.GermlineSample": participant_1_5_0.GermlineSample,
        }

    __slots__ = [
        "labSampleId",
        "sampleId",
        "LDPCode",
        "clinicalSampleDateTime",
        "maskedPid",
        "method",
        "participantId",
        "participantUid",
        "preparationMethod",
        "product",
        "programmePhase",
        "sampleCollectionOperationsQuestions",
        "sampleState",
        "sampleType",
        "sampleUid",
        "source",
        "storageMedium",
    ]

    def __init__(
        self,
        labSampleId,
        sampleId,
        LDPCode=None,
        clinicalSampleDateTime=None,
        maskedPid=None,
        method=None,
        participantId=None,
        participantUid=None,
        preparationMethod=None,
        product=None,
        programmePhase=None,
        sampleCollectionOperationsQuestions=None,
        sampleState=None,
        sampleType=None,
        sampleUid=None,
        source=None,
        storageMedium=None,
        validate=None,
        **kwargs
    ):
        """Initialise the participant_1_5_0.GermlineSample model.

        :param labSampleId:
            Lab sample identifier
        :type labSampleId: str
        :param sampleId:
            Sample identifier (e.g, LP00012645_5GH))
        :type sampleId: str
        :param LDPCode:
            LDP Code (Local Delivery Partner)
        :type LDPCode: None | str
        :param clinicalSampleDateTime:
            The time when the sample was received. In the format
            YYYY-MM-DDTHH:MM:SS+0000
        :type clinicalSampleDateTime: None | str
        :param maskedPid:
        :type maskedPid: None | str
        :param method:
            In GMS, this is how the sample was extracted from the participant
        :type method: None | Method
        :param participantId:
        :type participantId: None | str
        :param participantUid:
            Participant UId of the sample
        :type participantUid: None | str
        :param preparationMethod:
            Preparation method NOTE: In GMS, this has been deprecated in favour of
            Method and storageMedium
        :type preparationMethod: None | PreparationMethod
        :param product:
            Product of the sample
        :type product: None | Product
        :param programmePhase:
            Genomics England programme phase
        :type programmePhase: None | ProgrammePhase
        :param sampleCollectionOperationsQuestions:
            In Newborns BaMMs, this is operational sample collection questions
        :type sampleCollectionOperationsQuestions: None | SampleCollectionOperationsQuestions
        :param sampleState:
            In GMS, this is the sampleState as entered by the clinician in TOMs
        :type sampleState: None | str
        :param sampleType:
            In GMS, this is the sampleType as entered by the clinician in TOMs
        :type sampleType: None | str
        :param sampleUid:
        :type sampleUid: None | str
        :param source:
            Source of the sample
        :type source: None | SampleSource
        :param storageMedium:
            In GMS, this is what solvent/medium the sample was stored in
        :type storageMedium: None | StorageMedium
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.5.0"
